/**
 * DESCRIPTION OF THE FILE
 *
 * @author Michal Kravčenko
 * @date 13.6.18 -
 */

#include "Connection.h"

Connection::Connection(Neuron *n_in, Neuron *n_out, double edge_weight) {
    this->neuron_in = n_in;
    this->neuron_out = n_out;
    this->weight = edge_weight;
}

//Connection::~Connection() {
 //
//}

void Connection::adjust_weight(double value) {
    this->weight += value;
}

Neuron* Connection::get_neuron_in() {
    return this->neuron_in;
}

Neuron* Connection::get_neuron_out() {
    return this->neuron_out;
}

double Connection::get_weight() {
    return this->weight;
}

void Connection::pass_signal() {
    this->neuron_out->adjust_potential(this->neuron_in->get_state() * this->weight);
}

void Connection::set_weight(double value) {
    this->weight = value;
}
