/**
 * DESCRIPTION OF THE FILE
 *
 * @author Michal Kravčenko
 * @date 13.6.18 -
 */

#ifndef INC_4NEURO_CONNECTION_H
#define INC_4NEURO_CONNECTION_H

#include "../Neuron/Neuron.h"
class Neuron;

/**
 *
 */
class Connection {
private:
    /**
     *
     */
    Neuron *neuron_in = nullptr;

    /**
     *
     */
    Neuron *neuron_out = nullptr;

    /**
     *
     */
    double weight = 0.0;

    //TODO pridat gradient

public:

    /**
     *
     * @param[in] n_in
     * @param[in] n_out
     * @param[in] edge_weight
     */
    Connection(Neuron *n_in, Neuron *n_out, double edge_weight = 1.0);

//    Connection(Neuron *n_in, Neuron *n_out, Connection* ref_con);

    /**
     *
     */
    ~Connection()=default;

    /**
     *
     * @param[in] value
     */
    void adjust_weight(double value);

    /**
     *
     * @param[in] value
     */
    void set_weight(double value);

    /**
     *
     * @return
     */
    double get_weight();


    /**
     *
     */
    void pass_signal();


    /**
     *
     * @return
     */
    Neuron* get_neuron_in();

    /**
     *
     * @return
     */
    Neuron* get_neuron_out();

};


#endif //INC_4NEURO_CONNECTION_H
